
SC = {};

$.extend(SC, {

	//buttons
	buttonTable : function (buttonArray){
		var buttonTable = $("<table/>").addClass("buttonTable").attr('align', 'center');
		var buttons = $("<tr></tr>").appendTo(buttonTable);
		
		for(var i = 0; i < buttonArray.length; i++){
			var button = $("<div/>");
			var buttonTD = $('<td/>');
			buttonTD.append(button).appendTo(buttons);
			button.asComponent($.extend({
				type : "button"
			}, buttonArray[i]));
			buttonTable.data(i.toString(), buttonTD);
		}
		return buttonTable;
	},//buttonTable

	//ɶԻ
	Dialog : function(dialogPane,doOK){
		this.dialog = $('<div/>').addClass('platform_dialog');
		dialogPane.appendTo(this.dialog);
		var button1 = {
			text: "ȷ",
			handler: function() {
				doOK.call();
			}//handler
		};
		var button2 = {
			text: "ȡ",
			handler: function() {
				FR.closeDialog();
			}//handler
		};
		SC.buttonTable([button1,button2]).appendTo(this.dialog);
	},//Dialog
	
	//barry:еʼúϲ
//	emailAttrDialogPane : function(emailAttr) {
//		var emailAttrDialog = $('<div/>');
//		var table = $('<table/>');
//			table.appendTo($('<div/>')).parent().appendTo(emailAttrDialog);
//			var serverName = $('<input id="emailServer"/>');
//			serverName.attr('value', emailAttr.serverName);			
//			serverName.appendTo($('<td/>')).parent().appendTo($('<tr><td>ʼ</td></tr>')).parent().appendTo(table);
//			
//			var fromAddress = $('<input id="emailFrom"/>');
//			fromAddress.attr('value', emailAttr.fromAddress);	
//			fromAddress.appendTo($('<td/>')).parent().appendTo($('<tr><td>ַ</td></tr>')).parent().appendTo(table);
//		
//			var userName = $('<input id="emailUser"/>');
//			userName.attr('value', emailAttr.userName);
//			userName.appendTo($('<td/>')).parent().appendTo($('<tr><td>û</td></tr>')).parent().appendTo(table);
//					
//			var passWord = $('<input id="emailPassword" type="password"/>');
//			passWord.attr('value', emailAttr.passWord);
//			passWord.appendTo($('<td/>')).parent().appendTo($('<tr><td>룺</td></tr>')).parent().appendTo(table);
//			
//			var doOK = function() {
//				FR.ajax({					
//					url : FR.i18n.servletURL,
//					type : 'POST',
//					data : {
//						type : 'POST',
//						op : 'fr_schedule_EmailAttrSet', 
//						emailAttrJson : '{"serverName":"' + serverName.val() + '","fromAddress":"' + fromAddress.val() + '","userName":"' + userName.val() + '","passWord":"' + passWord.val() + '"}'
//					},
//					async : false,
//					complete : function(res, status) {
//						FR.Msg.alert('Ϣ', eval(res.responseText));
//					}
//	    		});
//				FR.closeDialog();
//			};
//			return new SC.Dialog(emailAttrDialog, doOK).dialog;
//	},
	
	
	//folderPane
	initFolderPane : function(tree) {
		var addFolderPane = $('<div></div>');
		var folderName = $('<input/>').attr('id','folderName')
		$('<span/>').text('ļ֣*').append(folderName).appendTo(addFolderPane);
		$('<p/>').appendTo(addFolderPane);
		var folderDesc = $('<textarea/>').attr({id : 'folderDesc', cols : '40', rows : '3'});
		$('<div/>').append($('<p/>').text('ļ')).append(folderDesc).appendTo(addFolderPane);
		var id;
		var parentId;
		$.extend(addFolderPane, {
			popu : function(folder) {
				folderName.val(folder.text);
				folderDesc.val(folder.description);
				id = folder.id;
				parentId = folder.parentId.substr(1);
			},
			
			clearData : function() {
				folderName.val('');
				folderDesc.val('');
				id = null;
				parentId = null;
			},
			
			getFolder : function() {
				if(!this.checkValid()) {
					return;
				}
				if (parentId == null && parentId == undefined) {
					var currentItem = tree.getTCT();			
					if (currentItem) {
						parentId = currentItem.id.substr(1);
					} else {
						//b:ĬӵĿ¼
						parentId = -1;
					}
				}
				
				var name = folderName.attr("value");
				var desc = folderDesc.attr("value");
				var folder = {};
				folder.parentId = parentId;
				folder.text = name;
				folder.hasChildren = true;
				folder.isexpand = true;
				folder.complete = true;
				folder.description = desc;
				if (id != null && id != undefined) {
					folder.id = id;
				}
				return folder;
			},
			
			checkValid : function() {
				if(!folderName.val()){
					folderName.focus();
					alert("ļ");
					return false;
				}
				return true;
			}
		});
		this.folderPane = addFolderPane;
	},
	
	addFolderDialog : function(tree){
			if (!this.folderPane) {
				this.initFolderPane(tree);	
			} 
			var folderPane = this.folderPane;
			var doOK = function() {
				var folder = folderPane.getFolder();
				if (!folder) {
					return;
				}
				var currentItem = tree.getTCT();
				FR.get(
					FR.i18n.servletURL,
					{
					op: "fr_catalog_addFolder",
					type : 'POST',
					folderJason: folder
					},
					function callback(jason){
						var item = FR.jsonDecode(jason);
						tree.addNode(currentItem,item);
					}
				);
				FR.closeDialog();
			};
			
		this.folderPane.clearData();
		return new SC.Dialog(this.folderPane, doOK).dialog;
	},
	
	editFolderDialog : function(tree) {
		var currentItem = tree.getTCT();
			if (!this.folderPane) {
				this.initFolderPane(tree);	
			} 
			var folderPane = this.folderPane;
			var doOK = function() {
				var folder = folderPane.getFolder();
				if (!folder) {
					return;
				}

				FR.get(
					FR.i18n.servletURL,
					{
					op: "fr_catalog_editFolder",
					type : 'POST',
					folderJason: folder
					},
					function callback(jason){
						var item = FR.jsonDecode(jason);
						tree.editNode(item);
					}
				);
				FR.closeDialog();
			};

		this.folderPane.popu(currentItem);
		return new SC.Dialog(this.folderPane, doOK).dialog;
	},

	initReportPane : function(tree) {
		var addReportPane = $('<div style="overflow:auto"></div>');

		var reportPath = $('<div><p>/ļ·*</p></div>').appendTo(addReportPane);
		var reportName = $('<input/>').attr('id', 'reportName');
		addReportPane.append($('<p/>').text('/ļ֣*')).append(reportName);

		var descrip = $('<textarea/>').attr('cols', 30).attr('rows', 3);
		$('<div/>').append($('<p/>').text('')).append(descrip).appendTo(addReportPane);
		
		var reportView = $('<input id="reportWrite" type="checkbox"/>');
		addReportPane.append($('<p/>').text('Ƿ')).append(reportView);
		
		var pathTable =$('<table></table>').appendTo(reportPath);
		var pathTR = $('<tr></tr>').appendTo(pathTable);

		var treePane = $('<div>loading</div>').addClass("tree scrollTree").appendTo(reportPath).hide();//
		var reportTD = $('<input id="reportPath" class="pathInput" readonly="true"/>');
		reportTD.wrap($('<td></td>')).parent().appendTo(pathTR);
		
		var selectButton = $('<div></div>');
		selectButton.wrap($("<td></td>")).parent().appendTo(pathTR);
		selectButton.asComponent({
			type : "button",
			text: "ѡ",
			handler: function() {
				if(treePane.html()=='loading'){
					$.get(
						FR.i18n.servletURL,
						{	
							type : 'POST',
							op: "fr_catalog_getReport"
						},
						function callback(jasonA){
							var treedata = FR.jsonDecode(jasonA);
							var o = {
								data: treedata,
								onnodeclick: function(){
									var currentItem = treePane.getTCT();
									if(currentItem.hasChildren){
										return;
									}
									$("#reportPath").attr("value", currentItem.path);
									$("#reportName").attr("value", currentItem.text);
									paraPane.setReport(currentItem);
								}
							};
							treePane.treeview(o);
						}
					);
				}
				treePane.toggle();
			}
		});
		
		//b:
		var paraPane = $('<div/>').addClass('platform_reportparameter');
		FR.PLATFORM.createParameterTable(paraPane);

		addReportPane.append(paraPane);
		var id;
		$.extend(addReportPane, {
			stopEditing : function() {
				paraPane.stopEditing();
			},
			
			getReport : function() {
				if(!this.checkvalid()){
					return;
				}
				var currentItem = tree.getTCT();
				var pD = currentItem.id.substr(1);
				var ph = $("#reportPath").attr("value");
				var name = $("#reportName").attr("value");
				var vw = !$("#reportWrite").attr("checked");
				var report = {parentId : pD, description : descrip.val(), path : ph, text : name, isView : vw};
				if (id != null && id != undefined) {
					report.id = id;
				}
				report.transmitParameters = paraPane.getParameters();
				return report;
			},
			
			popu : function(report) {				
//				treePane.setCurrentItem(report);
				reportTD.val(report.path);
				reportName.val(report.text);
				reportView.attr('checked', !report.isView);
				descrip.val(report.description);
				id = report.id.substr(1);
				paraPane.setReport(report);
				paraPane.updateParameters(report.transmitParameters);
			},
			
			clearData : function() {
				treePane.setCurrentItem(undefined);
				reportTD.val('');
				reportName.val('');
				reportView.attr('checked', false);
				descrip.val('');
				paraPane.removeAll();
				id = null;
			},
			
			checkvalid : function (){
				if(!$("#reportName").val()){
					$("#reportName").focus();
					alert("뱨");
					return false;
				}
				if(!$("#reportPath").val()){
					$("#reportPath").focus();
					alert("ѡ񱨱·");
					return false;
				}
				return true;
			}
		});
		this.reportPane = addReportPane;
		return addReportPane;
	},
	
	//b:ĳbugôģѰʱ֮
	addReportDialog : function(tree){
//			if (!this.reportPane) {
//				this.initReportPane(tree);
//			}
//			var reportPane = this.reportPane;
			var reportPane = this.initReportPane(tree);
			var doOK = function() {
				reportPane.stopEditing();
				var report = reportPane.getReport();
				if (!report) {
					return;
				}
				FR.get(
					FR.i18n.servletURL,
					{
						type : 'POST',
						op: "fr_catalog_addReport",
						reportJason: report
					},
					function callback(jason){//غ
						var item = FR.jsonDecode(jason);

						FR.PLATFORM.catalogDesignModule.filesArea.reportTable.addReport(item);
					}
				);
				FR.closeDialog();
			};
//		this.reportPane.clearData();
		reportPane.clearData();
//		return new SC.Dialog(this.reportPane, doOK).dialog;
		return new SC.Dialog(reportPane, doOK).dialog;
	},
	
	editReportDialog : function(tree, report){
//			if (!this.reportPane) {
//				this.initReportPane(tree);
//			}
//			var reportPane = this.reportPane;
			var reportPane = this.initReportPane(tree);
			var doOK = function() {
				reportPane.stopEditing();
				var report = reportPane.getReport();
				if (!report) {
					return;
				}
				FR.get(
					FR.i18n.servletURL,
					{
						type : 'POST',
						op : "fr_catalog_addReport",
						reportJason : report
					},
					function callback(jason){
						var item = FR.jsonDecode(jason);

						FR.PLATFORM.catalogDesignModule.filesArea.reportTable.editReport(item);
					}
				);
				FR.closeDialog();
			};
//		this.reportPane.popu(report);
		reportPane.popu(report);
//		return new SC.Dialog(this.reportPane, doOK).dialog;
		return new SC.Dialog(reportPane, doOK).dialog;
	},
	
	initURLPane : function(tree) {
		var addURLPane = $('<div style="overflow:auto"></div>');
		var reportName = $('<input id="urlName"/>');
		addURLPane.append($('<p/>').text('ʾ֣*')).append(reportName);
		var descrip = $('<textarea/>').attr('cols', 30).attr('rows', 3).attr('id', 'description');
		$('<div/>').append($('<p/>').text(':')).append(descrip).appendTo(addURLPane);

		var url = $('<input/>').attr('id', 'url');
		$('<div/>').append($('<p/>').text('Ӿ·')).append(url).appendTo(addURLPane);
		var id;

		$.extend(addURLPane, {
			getURL : function() {
				if(!this.checkvalid()){
					return;
				}
				var currentItem = tree.getTCT();
				var pD = currentItem.id.substr(1);
				var name = $("#urlName").attr("value");
				var ur = {parentId : pD, description : descrip.val(), url : url.val() , text : name};
				if (id != null) {
					ur.id = id;
				}
				return ur;
			},
			
			popu : function(ur) {
				id = ur.id.substr(1);
				reportName.val(ur.text);
				descrip.val(ur.description);
				url.val(ur.url);
			},
			
			clearData : function() {
				id = null;
				reportName.val('');
				descrip.val('');
				url.val('');
			}, 
			
			checkvalid : function(){
				if(!$("#urlName").val()){
					$("#urlName").focus();
					alert("");
					return false;
				}
				if(!url.val()){
					url.focus();
					alert("·");
					return false;
				}
				return true;
			}
		});
		
		this.URLPane = addURLPane;
	},
	
	addURLDialog : function(tree){
			if (!this.URLPane) {
				this.initURLPane(tree);
			}
			var urlPane = this.URLPane;
			var doOK = function() {
				var url = urlPane.getURL();
				if (!url) {
					return;
				}
				FR.get(
					FR.i18n.servletURL,
					{
						type : 'POST',
						op: "fr_catalog_addURL",
						urlJason: url
					},
					function callback(jason){
						var item = FR.jsonDecode(jason);
	
						FR.PLATFORM.catalogDesignModule.filesArea.URLTable.addURL(item);
					}//callback
				);
				FR.closeDialog();
		};

		this.URLPane.clearData();
		return new SC.Dialog(this.URLPane, doOK).dialog;
	},
	
	editURLDialog : function(tree, url){
			if (!this.URLPane) {
				this.initURLPane(tree);
			}
			var urlPane = this.URLPane;
			var doOK = function() {
			var url = urlPane.getURL();
			if (!url) {
				return;
			}
			FR.get(
				FR.i18n.servletURL,
				{
					type : 'POST',
					op: "fr_catalog_addURL",
					urlJason: url
				},
				function callback(jason){
					var item = FR.jsonDecode(jason);

					FR.PLATFORM.catalogDesignModule.filesArea.URLTable.editURL(item);
				}//callback
			);
			FR.closeDialog();
		};

		this.URLPane.popu(url);
		return new SC.Dialog(this.URLPane, doOK).dialog;
	},
	
	initAnalysisPane : function(tree) {
		var addAnalysisPane = $('<div style="overflow:auto"></div>');
		var showName = $('<input/>').attr('id', 'showName');
		$('<div/>').append($('<p/>').text('ƣ')).css('margin-bottom', 10).append(showName).appendTo(addAnalysisPane);
		
		var tdNamePane = $('<div><p>ݼ֣*</p></div>').appendTo(addAnalysisPane);
		var nameTable =$('<table></table>').appendTo(tdNamePane);
		var nameTR = $('<tr></tr>').appendTo(nameTable);

		var listPane = $('<div></div>').appendTo(tdNamePane).hide();
		listPane.css({width : 250, height:100, border : "1px solid #EEEEEE", overflow : "auto"});
		var tdName = $('<input id="tdName" class="pathInput" readonly="true"/>');
		tdName.wrap($('<td></td>')).parent().appendTo(nameTR);
		
		var selectButton = $('<div></div>');
		selectButton.wrap($("<td></td>")).parent().appendTo(nameTR);
		selectButton.asComponent({
			type : "button",
			text: "ѡ",
			handler: function() {
				listPane.__loading__(true);
				var randomstr = new Date().getTime() + "" + (Math.random() * 1000);
				$.get(
					FR.i18n.servletURL,
					{	
						type : 'POST',
						op: "adhoc_getdatanames",
						_ran : randomstr
					},
					function callback(jasonA){
						var names = FR.jsonDecode(jasonA);
						var datas = [];
						$.each(names, function(idx, item){
							datas[idx] = {value : item, text : item};
						});
						onnodeclick = function(){
							var data = listPane.getListItem();
							$("#showName").attr("value", data.getValue());
							$("#tdName").attr("value", data.getValue());
						};
						var treeConfig = {
								type : "list",
								data : FR.DataFactory.createArrayData(datas),
								width : 'auto',
								listeners : [{
									once: false ,
									eventName: 'click',
									action: function(){
										return onnodeclick();
									}
								}]
						};
						listPane.asComponent(treeConfig);
					}
				);
				listPane.__loading__(false);
				listPane.show();
			}
		});
		
		var descrip = $('<textarea/>').attr('cols', 30).attr('rows', 3).attr('id', 'description');
		$('<div/>').append($('<p/>').text(':')).append(descrip).appendTo(addAnalysisPane);
		var id;

		$.extend(addAnalysisPane, {
			init : function() {
				listPane.hide();
			},
			
			getAD : function() {
				if(!this.checkvalid()){
					return;
				}
				var currentItem = tree.getTCT();
				var pD = currentItem.id.substr(1);
				var name = showName.attr("value");
				var ur = {parentId : pD, description : descrip.val(), tdname : tdName.val() , text : name};
				if (id != null) {
					ur.id = id;
				}
				return ur;
			},
			
			popu : function(ur) {
				id = ur.id.substr(1);
				showName.val(ur.text);
				descrip.val(ur.description);
				tdName.val(ur.tdname);
			},
			
			clearData : function() {
				id = null;
				showName.val('');
				descrip.val('');
				tdName.val('');
			}, 
			
			checkvalid : function(){
				if(!tdName.val()){
					tdName.focus();
					alert("ѡݼ");
					return false;
				}
				if(!showName.val()){
					showName.focus();
					alert("");
					return false;
				}
				return true;
			}
		});
		
		this.AnalysisPane = addAnalysisPane;
	},
	
	addAnalyDialog : function(tree){
		if (!this.AnalysisPane) {
			this.initAnalysisPane(tree);
		}
		this.AnalysisPane.init();
		var AnalysisPane = this.AnalysisPane;
		var doOK = function() {
			var ad = AnalysisPane.getAD();
			if (!ad) {
				return;
			}
			FR.get(
				FR.i18n.servletURL,
				{
					type : 'POST',
					op: "fr_catalog_addAnaly",
					adJason: ad
				},
				function callback(jason){
					var item = FR.jsonDecode(jason);

					FR.PLATFORM.catalogDesignModule.filesArea.AnalyTable.addAnaly(item);
				}//callback
			);
			FR.closeDialog();
		};

		this.AnalysisPane.clearData();
		return new SC.Dialog(this.AnalysisPane, doOK).dialog;
	},
	
	editAnalyDialog : function(tree, ad){
		if (!this.AnalysisPane) {
			this.initAnalysisPane(tree);
		}
		this.AnalysisPane.init();
		var AnalysisPane = this.AnalysisPane;
		var doOK = function() {
			var ad = AnalysisPane.getAD();
			if (!ad) {
				return;
			}
			FR.get(
				FR.i18n.servletURL,
				{
					type : 'POST',
					op: "fr_catalog_addAnaly",
					adJason: ad
				},
				function callback(jason){
					var item = FR.jsonDecode(jason);
	
					FR.PLATFORM.catalogDesignModule.filesArea.AnalyTable.editAnaly(item);
				}//callback
			);
			FR.closeDialog();
		};

		this.AnalysisPane.popu(ad);
		return new SC.Dialog(this.AnalysisPane, doOK).dialog;
	},

	editParameterDialog : function (parameterPane, parameter, parameters, isnew){
		var editPane = editPane();
		editPane.populate(parameter);
		var doOK = function(){
			if(!(editPane.checkvalid())){
				return;
			}
			editPane.update(parameter);
			if(isnew){
				parameters.push(parameter);
			}
			parameterPane.loadParameter(parameters);
			FR.closeDialog();
		}
		
		function editPane(){
			var editPane = $('<div></div>');
			var parametername = $("<p>֣</p><input id='parametername'/>").appendTo(editPane);
			var parametertypecombo = $('<div></div>');
			parametertypecombo.wrap($('<p id="parametertype">ͣ</p>')).parent().appendTo(editPane);
			var parametertypeConfig = {
				type : "combo",
				editable : false,
				allowBlank : false,
				mode: 'local',
				items: [{value: "String", text: FR.i18n.Parameter_String},
						{value: "Integer", text: FR.i18n.Parameter_Integer},
						{value: "Double", text: FR.i18n.Parameter_Double},
						{value: "Date", text: FR.i18n.Parameter_Date},
						{value: "Boolean", text: FR.i18n.Parameter_Boolean},
						{value: "Formula", text: FR.i18n.Parameter_Formula}]
			};
			var parametertype = parametertypecombo.asComponent(parametertypeConfig);
			var valuePane = valuePane();
			valuePane.wrap($('<p>ֵ</p>')).parent().appendTo(editPane);
			parametertype.on(FR.Events.COLLAPSE, function(){
				if(parametertype.getValue()=="Date"){
					valuePane.setType("Date");
				}else if(parametertype.getValue()=="Boolean"){
					valuePane.setType("Boolean");
				}else{
					valuePane.setType("String");
				}
			});
			
			function valuePane(){
				var valuePane = $('<div></div>');
				var type = "";
				var stringinput = $('<input/>').css("width", "320px").appendTo(valuePane).hide();
				var datediv = $('<div></div>').appendTo(valuePane).hide();
				var timeConfig = {
					type : "datetime",
					width : 150,
					allowBlank : false,
					format : "yyyy-MM-dd"
				};
				var date = datediv.asComponent(timeConfig);
				var booleancheck = $('<input type="checkbox"/>').appendTo(valuePane).hide();
				valuePane.setValue = function(parametervalue){
					if(type == "Date"){
						date.setValue(parametervalue);
					}else if(type == "Boolean"){
						booleancheck.attr("checked", parametervalue);
					}else{
						stringinput.val(parametervalue);
					}
				}
				valuePane.getValue = function(){
					if(type == "Date"){
						return(date.getValue());
					}else if(type == "Boolean"){
						return booleancheck.attr("checked");
					}else {
						return stringinput.val();
					}
				}
				valuePane.setType = function(parametertype){
					type = parametertype;
					if(type == "Date"){
						datediv.showPane();
					}else if(type == "Boolean"){
						booleancheck.showPane();
					}else {
						stringinput.showPane();
					}
				}
				return valuePane;
			}//valuePane

			editPane.populate = function(parameter){
				editPane.find("#parametername").val(parameter.name);
				parametertype.setValue(parameter.type ? parameter.type : "String");
				valuePane.setType(parameter.type ? parameter.type : "String");
				valuePane.setValue(parameter.value);
			}
			editPane.update = function(parameter){
				parameter.name = $("#parametername").val();
				parameter.type = parametertype.getValue();
				parameter.value = valuePane.getValue();
			}
			editPane.checkvalid = function(){
				if(!$("#parametername").val()){
					$("#parametername").focus();
					alert("");
					return false;
				}
				return true;
			}
			return editPane;
		}//editPane

		return new SC.Dialog(editPane, doOK).dialog;
	}//addParameterDialog

});