$(function() {
	$.fn.generateButton = function(config) {
		this.config = {};
		$.extend(this.config, config, {editable : false});

		$.extend(this, {
			_initIconButton : function() {
				var self  = this;
				var eventhover = this.config.size == 'big'?'platform_bigmouseover':'platform_smallmouseover';
				var eventclick = this.config.size == 'big'?'platform_bigmousedown':'platform_smallmousedown';
				var width = this.config.size == 'big'?'24px':'16px';
				var height = this.config.size == 'big'?'24px':'16px';
				this.isIESix = $.browser.msie&&$.browser.version<7;
				if(this.isIESix){
					this.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+this.config.img+"')";
					this.filter_grey = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='"+this.config.img_grey+"')";
					this.img = $('<img/>').css('filter', this.filter).width(width).height(height).attr('src', '${servletURL}?op=resource&resource=/com/fr/web/images/platform/x.gif').attr('alt', this.config.text);
				}else{
					this.img = $('<img/>').width(width).height(height).attr('src', this.config.img).attr('alt', this.config.text);
				}
				this.setEnable(this.config.editable);
				this.attr('title', this.config.text).addClass(this.config.css).append(this.img)
				.mouseover(function(){
					if (self.isEnable()) {
						self.img.addClass(eventhover);
					}				
				}).mouseout(function(){
					if (self.isEnable()) {
						self.img.removeClass(eventhover);
					}
				}).mousedown(function(){
					if (self.isEnable()) {
						self.img.addClass(eventclick);
					}
				}).mouseup(function(){
					if (self.isEnable()) {
						self.img.removeClass(eventclick);
					}
				})
				.click(function() {
					if (!self.isEnable()) {
						return;
					}
					self.config.action();
				}.createDelegate(self));
			},
			
			setEnable : function(editable) {
				this.editable = editable;
				if(editable) {
					if(this.isIESix){
						this.img.css('filter', this.filter);
					}else{
						this.img.attr('src', this.config.img);
					}				
					this.removeClass('platform_button_disable');
				} else{
					if(this.isIESix){
						this.img.css('filter', this.filter_grey);
					}else{
						this.img.attr('src', this.config.img_grey);
					}				
					this.addClass('platform_button_disable');
				}
			},
			
			isEnable : function() {
				return this.editable;
			}
		});
		this._initIconButton();
	}
	
	$.extend(FR.PLATFORM, {
		_initSchedule : function() {
//			this.catalogDesignModule.show();
			$("body").append(this.catalogDesignModule);
			$("body").doLayout();
			this.catalogDesignModule._initTree();
			this.catalogDesignModule._init();
			window.onresize = function(){
				$("body").doLayout();
			}
		},
		catalogDesignModule : $('<div/>').attr('id', 'catalogDesign').addClass('platform_catalogDesignModule')
	});
	
	$.extend(FR.PLATFORM.catalogDesignModule, {
		_initTree : function() {
			$.extend(this.treeArea, {
				_init : function() {
					this.append(this.iconButtons.getContent()).append(this.tree.getContent());
				},
				
				iconButtons : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_tree_icons');
						this.content.append(this.createButtonTable(this.createButtons()));
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					rootState : function() {
						this.addfolderButton.setEnable(true);
						this.editfolderButton.setEnable(false);
						this.removefolderButton.setEnable(false);
						this.addcptButton.setEnable(false);
						this.addurlButton.setEnable(false);
						this.addAnalysisButton.setEnable(false);
					},
					
					activeState : function() {
						this.addfolderButton.setEnable(true);
						this.editfolderButton.setEnable(true);
						this.removefolderButton.setEnable(true);
						this.addcptButton.setEnable(true);
						this.addurlButton.setEnable(true);
						this.addAnalysisButton.setEnable(true);
					},
					
					defaultState : function() {
						this.addfolderButton.setEnable(false);
						this.editfolderButton.setEnable(false);
						this.removefolderButton.setEnable(false);
						this.addcptButton.setEnable(false);
						this.addurlButton.setEnable(false);
						this.addAnalysisButton.setEnable(false);
					}, 
					
					createButtonTable : function(buttons) {
						var tr = $('<tr/>');
						$.each(buttons, function(i) {
							tr.append($('<td/>').append(buttons[i]));
						});
						return $('<table/>').attr('align', 'center').addClass('platform_catalog_tree_icontable').append(tr);
					},
					
					
					//b:action 
					createButtons : function() {
						var imgurl = '${servletURL}?op=resource&resource=/com/fr/web/images/platform/';
						var cs = 'platform_catalog_tree_icon';
						var data = [];
						data[0] = {text : 'Ŀ¼', css : cs, img : imgurl + 'platform_addfolder.png', img_grey : imgurl + 'platform_addfolder_grey.png', size : 'big',
							action : function() {
								FR.showDialog("Ŀ¼",460,-1,SC.addFolderDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent()));
							}};
						data[1] = {text : '༭Ŀ¼', css : cs, img : imgurl + 'platform_editfolder.png', img_grey : imgurl + 'platform_editfolder_grey.png', size : 'big',
							action : function() {
								FR.showDialog("༭Ŀ¼",460,-1,SC.editFolderDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent()));			
							}};
						data[2] = {text : 'ɾĿ¼', css : cs, img : imgurl + 'platform_removefolder.png', img_grey : imgurl + 'platform_removefolder_grey.png', size : 'big',
							action : function() {
									var tree = FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent();
									var currentItem = tree.getTCT();
									if(!currentItem || currentItem.id == "0-1"){
										return;
									}
									var confirm = window.confirm("ȷɾļ"+currentItem.text+"ļڵļ");
									if(confirm){
										var folderId = currentItem.id.substr(1);//ȥǰ0
										$.get(
											FR.i18n.servletURL,
											{
											op: "fr_catalog_delFolder",
											folderId: folderId
											},
											function callback(){//Ӧ
												tree.delNode(currentItem);
											}
										);
									}
							}};
						data[3] = {text : 'ģ', css : cs, img : imgurl + 'platform_addcpt.gif', img_grey : imgurl + 'platform_addcpt_grey.gif', size : 'big',
							action : function() {
								FR.showDialog("ģ", 480, 530, SC.addReportDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent()));				
							}};
						data[4] = {text : '', css : cs, img : imgurl + 'platform_addurl.gif', img_grey : imgurl + 'platform_addurl_grey.gif', size : 'big',
							action : function() {
								FR.showDialog("", 480, -1, SC.addURLDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent()));											
							}};	
						data[5] = {text : 'ݷ', css : cs, img : imgurl + 'platform_addanaly.gif', img_grey : imgurl + 'platform_addanaly_grey.gif', size : 'big',
							action : function() {
								FR.showDialog("ݷ", 460, 360, SC.addAnalyDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent()));											
							}};	
							
						var buttons = [];
						buttons[0] = this.addfolderButton = $('<div/>');
						this.addfolderButton.generateButton(data[0]);
						buttons[1] = this.editfolderButton = $('<div/>');
						this.editfolderButton.generateButton(data[1]);
						buttons[2] = this.removefolderButton = $('<div/>');
						this.removefolderButton.generateButton(data[2]);
						buttons[3] = this.addcptButton = $('<div/>');
						this.addcptButton.generateButton(data[3]);
						buttons[4] = this.addurlButton = $('<div/>');
						this.addurlButton.generateButton(data[4]);
						buttons[5] = this.addAnalysisButton = $('<div/>');
						this.addAnalysisButton.generateButton(data[5]);
						
						return buttons;				
					}
				}, 
				
				tree : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_tree');
						this.initData();
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					initData : function() {
						var self = this;
						$.ajax({
							url : "${servletURL}?op=fr_catalog_getFolder",
							type : 'POST',
							complete : function(res, status) {
								self.treedata = FR.jsonDecode(res.responseText);
								var treeconfig = {
									onlyfolder : true,
									data : self.treedata,
									onnodeclick : function() {
										var currentFolder = self.content.getTCT();
										if (!currentFolder) {
											FR.PLATFORM.catalogDesignModule.treeArea.iconButtons.defaultState();
											FR.PLATFORM.SCHEDULE.hide();
											FR.PLATFORM.catalogDesignModule.filesArea.showBlank();
										} else if (currentFolder.id == '0-1') {
											FR.PLATFORM.catalogDesignModule.treeArea.iconButtons.rootState();
											FR.PLATFORM.SCHEDULE.hide();
		 									FR.PLATFORM.catalogDesignModule.filesArea.showFSAttr();
										} else {
											FR.PLATFORM.catalogDesignModule.treeArea.iconButtons.activeState();
											FR.PLATFORM.SCHEDULE.hide();
											FR.PLATFORM.catalogDesignModule.filesArea.show();
		 									FR.PLATFORM.catalogDesignModule.filesArea.showFiles(currentFolder);
										}
									} 
								};
								//barry:Ƿѡ˶ʱݿ⣬ûеĻѡ
								if(res.responseText == "nullSchDS"){
									FR.PLATFORM.moduleControls.doEvent($('.platform_smallserver'));
									alert("ѡƽ̨Դʱ֧accessݿ⣩");
								}
								self.content.treeview(treeconfig);
							}
						});
					}
					
					
				}
			});
			
			this.treeArea._init();
			
			
			$.extend(this.filesArea, {
				_init : function() {
					this.append(this.chooseFiles.hide())
						.append(this.reportTable.getContent().hide())
						.append(this.URLTable.getContent().hide())
						.append(this.AnalyTable.getContent().hide())
						.append(this.OutfileTable.getContent().hide())
						.append(this.FSAttrTable.getContent().hide());
				},
				
				chooseFiles : function() {
					var cf = $('<div/>').addClass('platform_catalog_choosefiles')
						.append($('<span/>').text("ѡ "))
						.append($('<span/>').text("ȫ ").addClass('platform_catalog_choosefiles_span')
						.click(function() {
							FR.PLATFORM.catalogDesignModule.filesArea.showAll();
						}))
						.append($('<span/>').text("ģ ").addClass('platform_catalog_choosefiles_span')
						.click(function() {
							FR.PLATFORM.catalogDesignModule.filesArea.showReport();
						}))
						.append($('<span/>').text("").addClass('platform_catalog_choosefiles_span')
						.click(function() {
							FR.PLATFORM.catalogDesignModule.filesArea.showURL();
						}))
						.append($('<span/>').text("").addClass('platform_catalog_choosefiles_span')
						.click(function() {
							FR.PLATFORM.catalogDesignModule.filesArea.showAnalysis();
						}))
						.append($('<span/>').text("ļ").addClass('platform_catalog_choosefiles_span')
						.click(function() {
							FR.PLATFORM.catalogDesignModule.filesArea.showOutfile();
						}));
					return cf;
				}(),
				
				reportTable : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_reports');
						this.table = $('<table/>').attr('align', 'center').attr('cellpadding', '0').attr('cellspacing', '0').addClass('platform_catalog_reportTable').append(this.createTableHead());
						this.content.append(this.table);
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					createTableHead : function() {
						return $('<thead/>').append($('<tr/>').addClass('platform_catalog_tablehead')
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '15%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '29%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '15%').text('ʹģ'))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '8%').text('ʽ'))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '8%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '25%').text('')));
					},
					
					deleteReport : function(report) {
						var confirm = window.confirm("ȷɾѡģļ");
						var self = this;
						if (confirm) {
							$.ajax({
								url :"${servletURL}?op=fr_catalog_delentrys",
								type : 'POST',
								data : {entryIds : report.id},
								complete : function(res, status) {
									if (status) {
										this.reports.remove(report);
										this.updateData(this.reports);
									}
								}.createDelegate(self)
							});
						}				
					},
					
					moveUpReport : function(report) {
						var index = this.reports.indexOf(report);
						if (index == 0 || this.reports.length < 2) {
							return;
						}
						var oldup = this.reports[index - 1];
						this.reports[index - 1] = this.reports[index];
						this.reports[index] = oldup;
						this.updateData(this.reports);
					},
					
					moveDownReport : function(report) {
						var index = this.reports.indexOf(report);
						if (index == this.reports - 1 || this.reports.length < 2) {
							return;
						}
						var olddown = this.reports[index + 1];
						this.reports[index + 1] = this.reports[index];
						this.reports[index] = olddown;
						this.updateData(this.reports);
					},
					
					addReport : function(report) {
						this.reports.push(report);
						this.updateData(this.reports);
					},
					
					editReport : function(report) {
						for (var i = 0, len = this.reports.length; i < len; i++) {
							if (this.reports[i].id == report.id) {
								this.reports[i] = report;
								break;
							}
						}
						this.updateData(this.reports);
					},
					
					editScheduleTask : function(report) {
						FR.PLATFORM.SCHEDULE.loadTask(report);
						FR.PLATFORM.catalogDesignModule.filesArea.hide();
						FR.PLATFORM.SCHEDULE.show();
					},
					
					generateOperationTD : function(report, index) {
						var buttons = this.defaultButtons(report, index);
						var tr = $('<tr/>');
						for(var i = 0, len = buttons.length; i < len; i++) {
							tr.append($('<td/>').append(buttons[i]));
						}
						return $('<td/>').attr('nowrap', 'nowrap').append($('<div/>').append($('<table/>').append(tr)));					
					},
					
					defaultButtons : function(report, index) {
						var buttons = [];
						var len = 5;
						for (var i = 0; i < len; i++) {
							buttons[i] = $('<div/>').data('report', report);
						}
						var imgurl = '${servletURL}?op=resource&resource=/com/fr/web/images/platform/';
						var cs = 'platform_catalog_table_icon';
						var data = [];

						data[0] = {text : '༭ģ', css : cs, img : imgurl + 'platform_editfile.png', img_grey : imgurl + 'platform_editfile.png', size : 'small',
							action : function() {
								FR.showDialog("༭ģ",460,530,SC.editReportDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent(), this.data('report')))
							}.createDelegate(buttons[0])};
							
						data[1] = {text : '༭ʱ', css : cs, img : imgurl + 'platform_scheduletask.png', img_grey : imgurl + 'platform_scheduletask_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.reportTable.editScheduleTask(this.data('report'));
							}.createDelegate(buttons[1])};
							
						data[2] = {text : 'ɾģ', css : cs, img : imgurl + 'platform_removefile.png', img_grey : imgurl + 'platform_removefile.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.reportTable.deleteReport(this.data('report'));
							}.createDelegate(buttons[2])};
							
						data[3] = {text : '', css : cs, img : imgurl + 'platform_upfile.png', img_grey : imgurl + 'platform_upfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.reportTable.moveUpReport(this.data('report'));
							}.createDelegate(buttons[3])};	
							
						data[4] = {text : '', css : cs, img : imgurl + 'platform_downfile.png', img_grey : imgurl + 'platform_downfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.reportTable.moveDownReport(this.data('report'));
							}.createDelegate(buttons[4])};						
						
						$.each(buttons, function(i) {
							buttons[i].generateButton(data[i]);
						});
						
						if (index == 0) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(false);
							buttons[4].setEnable(true);
						} else if (index == -1) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(true);
							buttons[4].setEnable(false);
						} else if (index == -2) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(false);
							buttons[4].setEnable(false);
						} else {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(true);
							buttons[4].setEnable(true);
						}
						
						
						return buttons;
					},
					
					generateReportTR : function(report, index) {
						var tr = $('<tr/>');
						tr.append($('<td/>').addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').text(report.text))
							.append(this.generateDescriptionTD(report.description))
							.append(this.generateLinkReportTD(report))
							.append($('<td/>').attr('nowrap', 'nowrap').text(report.isView ? 'Ԥ' : ''))
							.append($('<td/>').attr('nowrap', 'nowrap').text(report.transmitParameters ? '' : ''))
							.append(this.generateOperationTD(report, index));
							return tr;
					},
					
					generateDescriptionTD : function(description) {
						var td = $('<td/>').addClass('platform_tdcontent_hide');
						td.attr('title', description ? description : '').attr('nowrap', 'nowrap').text(description);
						return td;
					},
					
					generateLinkReportTD : function(report) {
						var td = $('<td/>').attr('nowrap', 'nowrap').addClass('platform_catalog_link');
						var ps = report.path.split("/");
						var parameters = report.transmitParameters==null?{}:report.transmitParameters;
						td.text(ps[ps.length - 1]);						
						td.click(function() {
							$.extend(parameters, {reportlet: report.path});
							if(!report.isView){
								$.extend(parameters, {op: "write"});
							}
							window.open(FR.buildServletUrl(parameters));
						});
						
						return td;
					},
					
					embellishBackground : function() {
						var trs = this.table.children('tbody').children('tr');
						$.each(trs, function(i) {
							if (i%2 == 0) {
								$(trs[i]).addClass('platform_catalog_tre');
							} else {
								$(trs[i]).addClass('platform_catalog_tro');
							}
						});
					},
					
					updateData : function(reports) {
						if (!this.reports) {
							this.reports = [];
						}
						
						this.reports = reports;
						this.updateTable(reports);
						this.embellishBackground();				
					},
					
					updateTable : function(reports) {
						this.table.children('tbody').remove();
						var tbody = $('<tbody/>');
						var self = this;
						$.each(reports, function(i) {
							var index = (i == reports.length - 1) ? -1 : i;
							if (reports.length == 1) {
								index = -2;
							}
							tbody.append(self.generateReportTR(reports[i], index));
						});
						this.table.append(tbody);
					}
				},
				
				URLTable : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_urls');
						this.table = $('<table/>').attr('align', 'center').attr('cellpadding', '0').attr('cellspacing', '0').addClass('platform_catalog_urlTable').append(this.createTableHead());
						this.content.append(this.table);
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					createTableHead : function() {
						return $('<thead/>').append($('<tr/>').addClass('platform_catalog_tablehead')
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '15%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '25%').text('')));
					},
					
					deleteURL : function(url) {
						var confirm = window.confirm("ȷɾѡҳ");
						var self = this;
						if (confirm) {
							$.ajax({
								url :"${servletURL}?op=fr_catalog_delentrys",
								type : 'POST',
								data : {entryIds : url.id},
								complete : function(res, status) {
									if (status) {
										this.urls.remove(url);
										this.updateData(this.urls);
									}
								}.createDelegate(self)
							});
						}
					},
					
					moveUpURL : function(url) {
						var index = this.urls.indexOf(url);
						if (index == 0 || this.urls.length < 2) {
							return;
						}
						var oldup = this.urls[index - 1];
						this.urls[index - 1] = this.urls[index];
						this.urls[index] = oldup;
						this.updateData(this.urls);
					},
					
					moveDownURL : function(url) {
						var index = this.urls.indexOf(url);
						if (index == this.urls - 1 || this.urls.length < 2) {
							return;
						}
						var olddown = this.urls[index + 1];
						this.urls[index + 1] = this.urls[index];
						this.urls[index] = olddown;
						this.updateData(this.urls);
					},
					
					addURL : function(url) {
						this.urls.push(url);
						this.updateData(this.urls);
					},
					
					editURL : function(url) {
						for (var i = 0, len = this.urls.length; i < len; i++) {
							if (this.urls[i].id == url.id) {
								this.urls[i] = url;
								break;
							}
						}
						this.updateData(this.urls);
					},
					
					generateOperationTD : function(url, index) {
						var buttons = this.defaultButtons(url, index);
						var tr = $('<tr/>');
						for(var i = 0, len = buttons.length; i < len; i++) {
							tr.append($('<td/>').append(buttons[i]));
						}
						return $('<td/>').attr('nowrap', 'nowrap').append($('<div/>').append($('<table/>').append(tr)));					
					},
					
					defaultButtons : function(url, index) {
						var buttons = [];
						var len = 4;
						for (var i = 0; i < len; i++) {
							buttons[i] = $('<div/>').data('url', url);
						}
						var imgurl = '${servletURL}?op=resource&resource=/com/fr/web/images/platform/';
						var cs = 'platform_catalog_table_icon';
						var data = [];

						data[0] = {text : '༭', css : cs, img : imgurl + 'platform_editfile.png', img_grey : imgurl + 'platform_editfile.png', size : 'small',
							action : function() {
								FR.showDialog("༭ģ",460,-1,SC.editURLDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent(), this.data('url')))
							}.createDelegate(buttons[0])};
							
						data[1] = {text : 'ɾ', css : cs, img : imgurl + 'platform_removefile.png', img_grey : imgurl + 'platform_removefile.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.URLTable.deleteURL(this.data('url'));
							}.createDelegate(buttons[1])};
							
						data[2] = {text : '', css : cs, img : imgurl + 'platform_upfile.png', img_grey : imgurl + 'platform_upfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.URLTable.moveUpURL(this.data('url'));
							}.createDelegate(buttons[2])};	
							
						data[3] = {text : '', css : cs, img : imgurl + 'platform_downfile.png', img_grey : imgurl + 'platform_downfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.URLTable.moveDownURL(this.data('url'));
							}.createDelegate(buttons[3])};
							
						$.each(buttons, function(i) {
							buttons[i].generateButton(data[i]);
						});
						
						if (index == 0) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(true);
						} else if (index == -1) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(false);
						} else if (index == -2) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(false);
						} else {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(true);
						}
						
						return buttons;
					},
					
					generateReportTR : function(url, index) {
						var tr = $('<tr/>');
						tr.append($('<td/>').addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').text(url.text))
							.append(this.generateDescriptionTD(url.description))
							.append(this.generateLinkURLTD(url.url))
							.append(this.generateOperationTD(url, index));
							return tr;
					},
					
					generateDescriptionTD : function(description) {
						var td = $('<td/>').addClass('platform_tdcontent_hide');
						td.attr('title', description ? description : '').attr('nowrap', 'nowrap').text(description);
						return td;
					},
					
					generateLinkURLTD : function(path) {
						var td = $('<td/>').attr('title', path).addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').addClass('platform_catalog_link');
						td.text(path);
						td.click(function() {
							window.open(path);
						});
						
						return td;
					},
					
					embellishBackground : function() {
						var trs = this.table.children('tbody').children('tr');
						$.each(trs, function(i) {
							if (i%2 == 0) {
								$(trs[i]).addClass('platform_catalog_tre');
							} else {
								$(trs[i]).addClass('platform_catalog_tro');
							}
						});
					},
					
					updateData : function(urls) {
						if (!this.urls) {
							this.urls = [];
						}
						
						this.urls = urls;
						this.updateTable(urls);
						this.embellishBackground();				
					},
					
					updateTable : function(urls) {
						this.table.children('tbody').remove();
						var tbody = $('<tbody/>');
						var self = this;
						$.each(urls, function(i) {
							var index = (i == urls.length - 1) ? -1 : i;
							if (urls.length == 1) {
								index = -2;
							}
							tbody.append(self.generateReportTR(urls[i], index));
						});
						this.table.append(tbody);
					}
				},
				
				AnalyTable : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_analys');
						this.table = $('<table/>').attr('align', 'center').attr('cellpadding', '0').attr('cellspacing', '0').addClass('platform_catalog_analyTable').append(this.createTableHead());
						this.content.append(this.table);
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					createTableHead : function() {
						return $('<thead/>').append($('<tr/>').addClass('platform_catalog_tablehead')
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '15%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text('Ԥ'))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '25%').text('')));
					},
					
					deleteAnaly : function(ad) {
						var confirm = window.confirm("ȷɾѡķ");
						var self = this;
						if (confirm) {
							$.ajax({
								url :"${servletURL}?op=fr_catalog_delentrys",
								type : 'POST',
								data : {entryIds : ad.id},
								complete : function(res, status) {
									if (status) {
										this.ads.remove(ad);
										this.updateData(this.ads);
									}
								}.createDelegate(self)
							});
						}
					},
					
					moveUpAnaly : function(ad) {
						var index = this.ads.indexOf(ad);
						if (index == 0 || this.ads.length < 2) {
							return;
						}
						var oldup = this.ads[index - 1];
						this.ads[index - 1] = this.ads[index];
						this.ads[index] = oldup;
						this.updateData(this.ads);
					},
					
					moveDownAnaly : function(ad) {
						var index = this.ads.indexOf(ad);
						if (index == this.ads - 1 || this.ads.length < 2) {
							return;
						}
						var olddown = this.ads[index + 1];
						this.ads[index + 1] = this.ads[index];
						this.ads[index] = olddown;
						this.updateData(this.ads);
					},
					
					addAnaly : function(ad) {
						this.ads.push(ad);
						this.updateData(this.ads);
					},
					
					editAnaly : function(ad) {
						for (var i = 0, len = this.ads.length; i < len; i++) {
							if (this.ads[i].id == ad.id) {
								this.ads[i] = ad;
								break;
							}
						}
						this.updateData(this.ads);
					},
					
					generateOperationTD : function(ad, index) {
						var buttons = this.defaultButtons(ad, index);
						var tr = $('<tr/>');
						for(var i = 0, len = buttons.length; i < len; i++) {
							tr.append($('<td/>').append(buttons[i]));
						}
						return $('<td/>').attr('nowrap', 'nowrap').append($('<div/>').append($('<table/>').append(tr)));					
					},
					
					defaultButtons : function(ad, index) {
						var buttons = [];
						var len = 4;
						for (var i = 0; i < len; i++) {
							buttons[i] = $('<div/>').data('ad', ad);
						}
						var imgurl = '${servletURL}?op=resource&resource=/com/fr/web/images/platform/';
						var cs = 'platform_catalog_table_icon';
						var data = [];

						data[0] = {text : '༭', css : cs, img : imgurl + 'platform_editfile.png', img_grey : imgurl + 'platform_editfile.png', size : 'small',
							action : function() {
								FR.showDialog("༭", 460, 360,SC.editAnalyDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent(), this.data('ad')))
							}.createDelegate(buttons[0])};
							
						data[1] = {text : 'ɾ', css : cs, img : imgurl + 'platform_removefile.png', img_grey : imgurl + 'platform_removefile.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.AnalyTable.deleteAnaly(this.data('ad'));
							}.createDelegate(buttons[1])};
							
						data[2] = {text : '', css : cs, img : imgurl + 'platform_upfile.png', img_grey : imgurl + 'platform_upfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.AnalyTable.moveUpAnaly(this.data('ad'));
							}.createDelegate(buttons[2])};	
							
						data[3] = {text : '', css : cs, img : imgurl + 'platform_downfile.png', img_grey : imgurl + 'platform_downfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.AnalyTable.moveDownAnaly(this.data('ad'));
							}.createDelegate(buttons[3])};
							
						$.each(buttons, function(i) {
							buttons[i].generateButton(data[i]);
						});
						
						if (index == 0) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(true);
						} else if (index == -1) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(false);
						} else if (index == -2) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(false);
						} else {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(true);
						}
						
						return buttons;
					},
					
					generateReportTR : function(ad, index) {
						var tr = $('<tr/>');
						tr.append($('<td/>').addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').text(ad.text))
							.append(this.generateDescriptionTD(ad.description))
							.append(this.generateLinkURLTD(ad.tdname))
							.append(this.generateOperationTD(ad, index));
							return tr;
					},
					
					generateDescriptionTD : function(description) {
						var td = $('<td/>').addClass('platform_tdcontent_hide');
						td.attr('title', description ? description : '').attr('nowrap', 'nowrap').text(description);
						return td;
					},
					
					generateLinkURLTD : function(tdname) {
						var td = $('<td/>').attr('title', tdname).addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').addClass('platform_catalog_link');
						td.text(tdname);
						td.click(function() {
							window.open(FR.buildServletUrl({op: 'adhoc_analysis', viewname: tdname}));
						});
						
						return td;
					},
					
					embellishBackground : function() {
						var trs = this.table.children('tbody').children('tr');
						$.each(trs, function(i) {
							if (i%2 == 0) {
								$(trs[i]).addClass('platform_catalog_tre');
							} else {
								$(trs[i]).addClass('platform_catalog_tro');
							}
						});
					},
					
					updateData : function(ads) {
						if (!this.ads) {
							this.ads = [];
						}
						
						this.ads = ads;
						this.updateTable(ads);
						this.embellishBackground();				
					},
					
					updateTable : function(ads) {
						this.table.children('tbody').remove();
						var tbody = $('<tbody/>');
						var self = this;
						$.each(ads, function(i) {
							var index = (i == ads.length - 1) ? -1 : i;
							if (ads.length == 1) {
								index = -2;
							}
							tbody.append(self.generateReportTR(ads[i], index));
						});
						this.table.append(tbody);
					}
				},
				
				OutfileTable : {
					_init : function() {
						this.content = $('<div/>');
						this.table = $('<table/>').attr('align', 'center').attr('cellpadding', '0').attr('cellspacing', '0').addClass('platform_catalog_analyTable').append(this.createTableHead());
						this.content.append(this.table);
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					},
					
					createTableHead : function() {
						return $('<thead/>').append($('<tr/>').addClass('platform_catalog_tablehead')
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '15%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text(''))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '30%').text('λ'))
							.append($('<th/>').attr('nowrap', 'nowrap').css('width', '25%').text('')));
					},
					
					deleteOutfile : function(of) {
						var confirm = window.confirm("ȷɾѡļ");
						var self = this;
						if (confirm) {
							$.ajax({
								url :"${servletURL}?op=fr_catalog_delentrys",
								type : 'POST',
								data : {entryIds : of.id},
								complete : function(res, status) {
									if (status) {
										this.ofs.remove(of);
										this.updateData(this.ofs);
									}
								}.createDelegate(self)
							});
						}
					},
					
					moveUpOutfile : function(of) {
						var index = this.ofs.indexOf(of);
						if (index == 0 || this.ofs.length < 2) {
							return;
						}
						var oldup = this.ofs[index - 1];
						this.ofs[index - 1] = this.ofs[index];
						this.ofs[index] = oldup;
						this.updateData(this.ofs);
					},
					
					moveDownOutfile : function(of) {
						var index = this.ofs.indexOf(of);
						if (index == this.ofs - 1 || this.ofs.length < 2) {
							return;
						}
						var olddown = this.ofs[index + 1];
						this.ofs[index + 1] = this.ofs[index];
						this.ofs[index] = olddown;
						this.updateData(this.ofs);
					},
					
					addOutfile : function(ad) {
						this.ofs.push(ad);
						this.updateData(this.ofs);
					},
					
					editOutfile : function(ad) {
						for (var i = 0, len = this.ofs.length; i < len; i++) {
							if (this.ofs[i].id == ad.id) {
								this.ofs[i] = ad;
								break;
							}
						}
						this.updateData(this.ofs);
					},
					
					generateOperationTD : function(of, index) {
						var buttons = this.defaultButtons(of, index);
						var tr = $('<tr/>');
						for(var i = 0, len = buttons.length; i < len; i++) {
							tr.append($('<td/>').append(buttons[i]));
						}
						return $('<td/>').attr('nowrap', 'nowrap').append($('<div/>').append($('<table/>').append(tr)));					
					},
					
					defaultButtons : function(of, index) {
						var buttons = [];
						var len = 4;
						for (var i = 0; i < len; i++) {
							buttons[i] = $('<div/>').data('of', of);
						}
						var imgurl = '${servletURL}?op=resource&resource=/com/fr/web/images/platform/';
						var cs = 'platform_catalog_table_icon';
						var data = [];

						data[0] = {text : '鿴ļ', css : cs, img : imgurl + 'platform_editfile.png', img_grey : imgurl + 'platform_editfile.png', size : 'small',
							action : function() {
//								FR.showDialog("鿴ļ", 460, 360,SC.editAnalyDialog(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent(), this.data('of')))
							}.createDelegate(buttons[0])};
							
						data[1] = {text : 'ɾļ', css : cs, img : imgurl + 'platform_removefile.png', img_grey : imgurl + 'platform_removefile.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.OutfileTable.deleteOutfile(this.data('of'));
							}.createDelegate(buttons[1])};
							
						data[2] = {text : '', css : cs, img : imgurl + 'platform_upfile.png', img_grey : imgurl + 'platform_upfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.OutfileTable.moveUpOutfile(this.data('of'));
							}.createDelegate(buttons[2])};	
							
						data[3] = {text : '', css : cs, img : imgurl + 'platform_downfile.png', img_grey : imgurl + 'platform_downfile_grey.png', size : 'small',
							action : function() {
								FR.PLATFORM.catalogDesignModule.filesArea.OutfileTable.moveDownOutfile(this.data('of'));
							}.createDelegate(buttons[3])};
							
						$.each(buttons, function(i) {
							buttons[i].generateButton(data[i]);
						});
						
						if (index == 0) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(true);
						} else if (index == -1) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(false);
						} else if (index == -2) {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(false);
							buttons[3].setEnable(false);
						} else {
							buttons[0].setEnable(true);
							buttons[1].setEnable(true);
							buttons[2].setEnable(true);
							buttons[3].setEnable(true);
						}
						
						return buttons;
					},
					
					generateOutfileTR : function(of, index) {
						var tr = $('<tr/>');
						tr.append($('<td/>').addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').text(of.text))
							.append(this.generateDescriptionTD(of.description))
							.append(this.generateLinkURLTD(of.path))
							.append(this.generateOperationTD(of, index));
							return tr;
					},
					
					generateDescriptionTD : function(description) {
						var td = $('<td/>').addClass('platform_tdcontent_hide');
						td.attr('title', description ? description : '').attr('nowrap', 'nowrap').text(description);
						return td;
					},
					
					generateLinkURLTD : function(path) {
						var td = $('<td/>').attr('title', path).addClass('platform_tdcontent_hide').attr('nowrap', 'nowrap').addClass('platform_catalog_link');
						td.text(path);
						td.click(function() {
							window.open(FR.buildServletUrl({op: 'adhoc_analysis', viewname: path}));
						});
						
						return td;
					},
					
					embellishBackground : function() {
						var trs = this.table.children('tbody').children('tr');
						$.each(trs, function(i) {
							if (i%2 == 0) {
								$(trs[i]).addClass('platform_catalog_tre');
							} else {
								$(trs[i]).addClass('platform_catalog_tro');
							}
						});
					},
					
					updateData : function(ofs) {
						if (!this.ofs) {
							this.ofs = [];
						}
						
						this.ofs = ofs;
						this.updateTable(ofs);
						this.embellishBackground();				
					},
					
					updateTable : function(ofs) {
						this.table.children('tbody').remove();
						var tbody = $('<tbody/>');
						var self = this;
						$.each(ofs, function(i) {
							var index = (i == ofs.length - 1) ? -1 : i;
							if (ofs.length == 1) {
								index = -2;
							}
							tbody.append(self.generateOutfileTR(ofs[i], index));
						});
						this.table.append(tbody);
					}
				},
					
				FSAttrTable : {
					_init : function() {
						this.content = $('<div/>').addClass('platform_catalog_analys');
						var title = $('<div style="border-bottom: 1px solid rgb(51, 51, 51); padding: 10px; font-size: 12px; color: rgb(85, 170, 237);"/>').text("FineServerҳ").appendTo(this.content);
						var attrContent = $('<div id="basicset" style="padding: 20px; overflow: auto;"/>').appendTo(this.content);
						var table = $('<table style="border-collapse:collapse;" />').appendTo(attrContent);
						
						var FSAttr = {
							showFSHome: false,
							showFSBanner: true,
							fsHome: "",
							fsTitle: "",
							showFSTree:false
						};
						$.ajax({
							url : '${servletURL}?op=fr_catalog_getfsinfo',
							type : 'POST',
							async : false,
							complete : function(res, status) {
								if (res.responseText == null||res.responseText == "") {
									return;
								}
								FSAttr = FR.jsonDecode(res.responseText);							
							}
						});
						
						var showHomeTR = $('<tr style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;"/>').appendTo(table);
						var showHomeTD = $('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">').appendTo(showHomeTR);
						$('<div style="display: inline;">Ƿʾҳ</div>').addClass('platform_server_areatitle').appendTo(showHomeTD);
						var showHomeEditor = $('<input style="display: inline; width: 50px;" type="checkbox" name="showHomeEditor"/>');
						if(FSAttr.showFSHome) {
							showHomeEditor.attr("checked","checked");
						}
						showHomeEditor.appendTo(showHomeTD);							
						$('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">op=fsʱʾõҳ</td>')
							.width("100%").addClass('platform_server_areanote').appendTo(showHomeTR);
						
						$('<tr><td><br>ҳ</td></tr>').addClass('platform_server_areatitle').appendTo(table);
						var homeTR = $('<tr style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;"/>').appendTo(table);
						var homeTD = $('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">').appendTo(homeTR);
						var homeEditor = $('<input id="homeEditor">').addClass('platform_server_titlenote').width('300');
						homeEditor.attr('value',FSAttr.fsHome);
						homeEditor.appendTo(homeTD);							
						$('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">ڴҪõҳַ</td>')
							.width("100%").addClass('platform_server_areanote').appendTo(homeTR);
							
						var showBannerTR = $('<tr style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;"/>').appendTo(table);
						var showBannerTD = $('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">').appendTo(showBannerTR);
						$('<div style="display: inline;">Ƿʾ</div>').addClass('platform_server_areatitle').appendTo(showBannerTD);
						var showBannerEditor = $('<input style="display: inline; width: 50px;" type="checkbox" name="showBannerEditor"/>');
						if(FSAttr.showFSBanner) {
							showBannerEditor.attr("checked","checked");
						}
						showBannerEditor.appendTo(showBannerTD);							
						$('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">op=fsʱҳϷʾ</td>')
							.width("100%").addClass('platform_server_areanote').appendTo(showBannerTR);
						
						$('<tr><td><br>⣺</td></tr>').addClass('platform_server_areatitle').appendTo(table);
						var titleTR = $('<tr style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;"/>').appendTo(table);
						var titleTD = $('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">').appendTo(titleTR);
						var titleEditor = $('<input id="titleEditor">').addClass('platform_server_titlenote').width('300');
						titleEditor.attr('value',FSAttr.fsTitle);
						titleEditor.appendTo(titleTD);							
						$('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">ڴʾop=fsҳϵı⡣</td>')
							.width("100%").addClass('platform_server_areanote').appendTo(titleTR);
							
						var showTreeTR = $('<tr style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;"/>').appendTo(table);
						var showTreeTD = $('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">').appendTo(showTreeTR);
						$('<div style="display: inline;">Ƿչڵ㣺</div>').addClass('platform_server_areatitle').appendTo(showTreeTD);
						var showTreeEditor = $('<input style="display: inline; width: 50px;" type="checkbox" name="showTreeEditor"/>');
						if(FSAttr.showFSTree) {
							showTreeEditor.attr("checked","checked");
						}
						showTreeEditor.appendTo(showTreeTD);							
						$('<td style="border-bottom: 1px solid rgb(234, 234, 234); padding-bottom: 10px;">ڵȫչ</td>')
							.width("100%").addClass('platform_server_areanote').appendTo(showTreeTR);
							
						var buttonTR = $('<tr>').appendTo(table);
						var buttonTD = $('<td>').appendTo(buttonTR);
						$('<br><br><br>').appendTo(buttonTD);
						var submitcontent = $('<div/>').appendTo(buttonTD);			
						var buttonS = $('<input type="submit" value="ύ"/>').addClass('platform_server_titlenote').click(function() {	
							var isShowHome = showHomeEditor[0].checked ? true : false;
							var isShowBanner = showBannerEditor[0].checked ? true : false;
							var isShowTree = showTreeEditor[0].checked ? true : false;
							var fsAttrSub = {
								showFSBanner: isShowBanner,
								showFSHome: isShowHome,
								fsHome: homeEditor.val(),
								fsTitle: titleEditor.val(),
								showFSTree:isShowTree
							}
							FR.showLoadingDialog({width : 310, height : 80, title : "FineServer", text : "ύ"});			
							FR.ajax({
								url : '${servletURL}?op=fr_catalog_fsattrset',
								type : 'POST',
								data : {
									type : 'POST',
	
									fsAttrJson : fsAttrSub
								},
								complete : function(res, status) {
									FR.hideLoadingDialog();
									var fsAttrStatus = res.responseText;							
									if(fsAttrStatus=="success"){
										alert("ύɹ");
									}else{
										alert("ύʧ" + fsAttrStatus);
									}
								}
				    		});
						}).width("50px").appendTo(submitcontent);
					},
					
					getContent : function() {
						if (!this.content) {
							this._init();
						}
						return this.content;
					}
				},
				
				showFiles : function(folder) {
					var id = folder.id;
					var self = this;
					$.ajax({
						url : '${servletURL}?op=fr_catalog_getfiles',
						type : 'POST',
						data : {folderID : id},
						complete : function(res, status) {
							if (!res.responseText) {
								return;
							}
							var files = FR.jsonDecode(res.responseText);
							self.initData(files);
							self.showAll();
						}
					});
				},				
								
				initData : function(files) {
					var reports = [];
					var urls = [];
					var ads = [];
					var outfiles = [];
					for (var i = 0, len = files.length; i < len; i++) {
						if (files[i].url != null) {
							urls.push(files[i]);
						} else if (files[i].tdname != null) {
							ads.push(files[i]);
						} else if (files[i].type == 2){
							reports.push(files[i]);	
						} else if (files[i].type == 1){
							outfiles.push(files[i]);
						}
					}
					this.reportTable.updateData(reports);
					this.URLTable.updateData(urls);
					this.AnalyTable.updateData(ads);
					this.OutfileTable.updateData(outfiles);
				},
				
				showAll : function() {
					this.chooseFiles.show();
					this.reportTable.getContent().show();
					this.URLTable.getContent().show();
					this.AnalyTable.getContent().show();
					this.OutfileTable.getContent().show();
					this.FSAttrTable.getContent().hide();
//					this.parent().doLayout();
				},
								
				showReport : function() {
					this.chooseFiles.show();
					this.reportTable.getContent().show();
					this.URLTable.getContent().hide();
					this.AnalyTable.getContent().hide();
					this.OutfileTable.getContent().hide();
					this.FSAttrTable.getContent().hide();
				},
				
				showURL : function() {
					this.chooseFiles.show();
					this.URLTable.getContent().show();
					this.reportTable.getContent().hide();
					this.AnalyTable.getContent().hide();
					this.OutfileTable.getContent().hide();
					this.FSAttrTable.getContent().hide();
				},
				
				showAnalysis : function() {
					this.chooseFiles.show();
					this.URLTable.getContent().hide();
					this.reportTable.getContent().hide();
					this.AnalyTable.getContent().show();
					this.OutfileTable.getContent().hide();
					this.FSAttrTable.getContent().hide();
				},
				
				showOutfile : function() {
					this.chooseFiles.show();
					this.OutfileTable.getContent().show();
					this.URLTable.getContent().hide();
					this.reportTable.getContent().hide();
					this.AnalyTable.getContent().hide();
					this.FSAttrTable.getContent().hide();
				},
				
				showFSAttr : function() {					
					this.chooseFiles.hide();
					this.URLTable.getContent().hide();
					this.reportTable.getContent().hide();
					this.AnalyTable.getContent().hide();
					this.OutfileTable.getContent().hide();
					this.FSAttrTable.getContent().show();
				},
				
				showBlank : function() {
					this.chooseFiles.hide();
					this.reportTable.getContent().hide();
					this.URLTable.getContent().hide();
					this.AnalyTable.getContent().hide();
					this.OutfileTable.getContent().hide();
					this.FSAttrTable.getContent().hide();
				}
			});
			this.filesArea._init();
			
			this.initCenterPane();
					
			this.initTree = true;
		},
		
		initCenterPane : function() {
			this.centerPane = $('<div/>').addClass('platform_catalog_centerPane');
			this.centerPane.append(this.filesArea);
			FR.PLATFORM.SCHEDULE._init();
			FR.PLATFORM.SCHEDULE.hide();
			this.centerPane.append(FR.PLATFORM.SCHEDULE);
		},
		
		_init : function() {
			if (this.initfinish) {
				return;
			}
			if (!this.initTree) {
				this._initTree();
			}
			var content = this;
			content.asComponent({type : "border", items:[{
					region : 'west',
					el : this.treeArea
				}, {
					region : 'center',
					el : this.centerPane
				}]});
			//barry:ͷǱһchromeҪdoLayoutʾҳ棬ֻʾߵwest
			content.doLayout();
			content.doLayout();
			$(window).resize(function() {
				content.doLayout();
			});
			this.initfinish = true;
		},
		
		treeArea : $('<div/>').addClass('platform_catalog_treearea').width('240px'),
		
		filesArea : $('<div/>').addClass('platform_catalog_filesarea')
	});
	
	FR.PLATFORM.SCHEDULE = $('<div/>').addClass('platform_schedule');
	
	$.extend(FR.PLATFORM.SCHEDULE, {
		_init : function() {
			if (this.inital) {
				return;
			}
			this.taskPane = this.createTaskPane();
			this.taskPane.appendTo(this).hide();
			this.processPane = this.createProcessPane(FR.PLATFORM.catalogDesignModule.treeArea.tree.getContent());
			this.processPane.appendTo(this).hide();
			this.inital = true;
		}
	});
});