/*
 * b/sʵֵJControlPane
 */
(function($){
	$.fn.jlist = function(opts){
		var op = {
			needhead:false,// ǷҪʾӡɾȲ˵ť
			onnodeclick:false,// һѡǴ
			initaction:false,
			// ִж              ɾ                 
			operation : {addaction:false, deleteaction:false, renameaction:false},
			cpPrefix: "_list_",
			url:false,
			iconpath:"${servletURL}?op=resource&resource=/com/fr/web/images/platform/jlist/user.png",
			addiconpath:"${servletURL}?op=resource&resource=/com/fr/web/images/platform/jlist/add.png",
			deleteiconpath:"${servletURL}?op=resource&resource=/com/fr/web/images/platform/jlist/delete.png",
			editiconpath:"${servletURL}?op=resource&resource=/com/fr/web/images/platform/jlist/user_edit.png",
			data: FR.DataFactory.createEmptyData(),
			beforeSelectItemChange : function() {
				return true;
			}
		}
		$.extend(op, opts);
		if (op.url){
			op.data = FR.DataFactory.createJSONData({widetURL: op.url});
		}
		
		var me = $(this);
        var meid = me.attr("id");
        if (meid == null || meid == "") {
            meid = "jquery_jlist" + new Date().getTime();
            me.attr("id", meid);
        }

        var html = [];
        op.data.resetStatusKeepData(allPara());
        buildControlList(op.data, html);
        me.addClass("bbit-cp-bwrap").html(html.join(""));	
        initEvent(me);
		if (op.initaction){
			op.initaction.apply(this, arguments);
		}
        scrollEvent();
        
        function checkViewScroll(data) {
	    	if (data.length < FR.limitData) {
	    		me.need2Scroll = false;
	    	} else {
	    		me.need2Scroll = true;
	    	}  
    	}
        
        function scrollEvent() {
        	me.scroll(function() {
   				if (me.need2Scroll && $(this).scrollTop() + $(this).height() == this.scrollHeight) {
   					scrollLoadMoreData();
   				}
   			});
        }
        
        function scrollLoadMoreData() {
	    	op.data.resetStatusKeepData(allPara(op.data.getLength()));
	    	var data = op.data.appendData();
	    	checkViewScroll(data);   	
	    	addData2View(data);
	    }
	    
	    function  allPara(start, limit) {
	    	var para = op.widget.createDependencePara4Data();
	    	if (op.widget.searchText || op.widget.searchText == 0) {
	    		para.parameter.filter = op.widget.searchText;
	    	}
	
	    	para.parameter.startIndex = start ? start : 0;
	    	para.parameter.limitIndex = limit ? limit : FR.limitData;
	    	return para;
	    }
	    
	    function addData2View(data) {
	    	var ulContent = $('ul.bbit-cp-content', me);
	    	var startIndex = $('li', ulContent).length;
	    	for (var i = 0, len = data.length; i < len; i++) {
	    		var li = createLi(data[i], i + startIndex);
	    		ulContent.append(li);
	    		initLiEvent(li);
	    	}
	    }
	    
	    function createLi(record, index) {
	    	return $('<li/>').addClass('bbit-cp-node').attr('id', meid + op.cpPrefix + index)
	    		.append($('<div/>').addClass('bbit-cp-node-el').append($("<a hideFocus class='bbit-cp-node-anchor' tabIndex=1></a>")
	    		.append($("<span unselectable='on'/>").text(record.getShowValue()))));
	    }
        
        function buildControlList(data, ht){
        	ht.push("<div class='bbit-cp-body'>");
        	if (op.needhead) {
        	   createHeader(ht);
        	}
        	ht.push("<ul class='available bbit-cp-content'>");
        	checkViewScroll(data.getRecords());
        	var len = data.getLength();
        	for (var i = 0; i < len; i ++){
        		addItem(data.getRecord(i), ht, i);
        	} 
        	ht.push("</ul>");
        	ht.push("</div>");     	
        }
        
        function createHeader(ht){
        	ht.push("<div class='bbit-cp-header'>");
        	ht.push("<span class='bbit-cp-operation'>", "<img class='bbit-cp-operation-add' src='", op.addiconpath, "'>", "</span>");
        	ht.push("<span class='bbit-cp-operation'>", "<img class='bbit-cp-operation-delete' src='", op.deleteiconpath, "'>", "</span>");
        	ht.push("<span class='bbit-cp-operation'>", "<img class='bbit-cp-operation-edit' src='", op.editiconpath, "'>", "</span>");
        	ht.push("</div>");
        }
        
		function addItem(record, ht, index){
			ht.push("<li class='bbit-cp-node' id='", meid, op.cpPrefix,index,"'>");
			ht.push("<div class='bbit-cp-node-el'>");
			ht.push("<a hideFocus class='bbit-cp-node-anchor' tabIndex=1>");
            ht.push("<span unselectable='on'>", record.getShowValue(), "</span>");
            ht.push("</a>");
			ht.push("</div>");
			ht.push("</li>");
		}
		
		function initEvent(parent){
			var nodes = $("li.bbit-cp-node", me);
			nodes.each(function(i, item){
				initLiEvent($(item));
			});
			var operations = $(".bbit-cp-header .bbit-cp-operation", me);
			operations.each(function(e){
				$(this).unbind("click", operation).bind("click", operation);
			});
		}
		
		function initLiEvent(li) {
				li.hover(function(){
					$(this).addClass("bbit-cp-node-over");
				}, function(){
					$(this).removeClass("bbit-cp-node-over");
				}).unbind("click", doSelected).bind("click", doSelected);
		}
		
		function doSelected(e){
			var id = $(this).attr("id");      
            if (op.cindex){
            	$("#"+ meid + op.cpPrefix + op.cindex).removeClass("bbit-cp-node-selected");
            }
            var oldItem = op.cindex ? op.data.getRecords()[op.cindex] : null; 
            var index = getItemIndex(id);
            var newItem = op.data.getRecords()[index];
            if (newItem != oldItem && !op.beforeSelectItemChange()) {
				return;
			}
            op.cindex = index;
            $(this).addClass("bbit-cp-node-selected");
            if (op.onnodeclick){
            	op.onnodeclick.call(this, index, newItem, oldItem);
            }                
		}
		
		function getItemIndex(id){			
			id = id.replace(meid + op.cpPrefix, "");
			return id;
		}
		
		function operation(e){
			var et = e.target || e.srcElement;
			if (et.tagName == "IMG") {
				if ($(et).hasClass("bbit-cp-operation-add")){
					var name = prompt(FR.i18n.Privilege_Input_A_Name);
			        if (!name){
			        	FR.Msg.toast(FR.i18n.Privilege_Name_Cannot_Be_Null);				  
			        } else {
			           var item = {text : name, value : name};
			           doAddItem(FR.createItemRecord(item));
			        }
				} else if ($(et).hasClass("bbit-cp-operation-delete")){
					doDeleteItem();
				} else {
					doEditItem();
				}
			}
		}
		// 
		function doAddItem(record){
			op.data.addRecord(record);
			var ht = [];
			addItem(record, ht, op.data.getLength() - 1);
			$("ul.bbit-cp-content", me).append(ht.join(""));
			initEvent(me);
			if (op.operation.addaction && op.needhead){
				op.operation.addaction.call(this, record);
			}
						
		}
		// ɾ
		function doDeleteItem(){
			var currentIndex = getSelectedIndex();
			var record = getSelectedItem();
			if (currentIndex == -1){
				FR.Msg.toast(FR.i18n.Privilege_Selected_None_Of_Any_Items + "!");
				return false;
			}
			var orgLen = op.data.getLength();
			// richer:ɾԪ
			op.data.removeRecord(currentIndex);
			// richer:idҪӦı仯
			$("#" + meid + op.cpPrefix + currentIndex, me).remove();
			for (var i = currentIndex; i < orgLen; i ++){
				var cid = meid + op.cpPrefix + i;
				var nid = meid + op.cpPrefix + (i - 1);
				$("#" + cid, me).attr("id", nid);
			}
			var next = $("#" + meid + op.cpPrefix + currentIndex);		
			if (next.length != 0){
				next.addClass("bbit-cp-node-selected");
			}
			if (op.operation.deleteaction && op.needhead){
				op.operation.deleteaction.call(this, record);
			}
		}
		// ༭
		function doEditItem(){
			var record = getSelectedItem();
			if (!record){
				FR.Msg.toast(FR.i18n.Privilege_Selected_None_Of_Any_Items + "!");
				return false;
			}
			var oldname = record.getShowValue();
			var newname = prompt("Rename", oldname);
			record.setShowValue(newname);
			// richer:Ҫıʾֵ
			var li = $("#" + meid + op.cpPrefix + getSelectedIndex());
			$("span", li).text(newname);
			if (op.operation.renameaction && oldname != newname && op.needhead){
				op.operation.renameaction.call(this, record, oldname);
			}
		}
		
		function doClear(){
			op.data = [];
			$(".bbit-cp-node", me).remove();
		}
		
		// null:none selected
		function getSelectedItem(){
			var index = getSelectedIndex();
			return index != -1 ? op.data.getRecords()[index] : null;
		}
		
		// -1:none selected
		function getSelectedIndex(){
			var currentLi = $("li.bbit-cp-node-selected", me);
			var index = currentLi.length != 0 ? currentLi.attr("id").replace(meid + op.cpPrefix, "") : -1;
			return index;
		}

		me[0].t = {
			addItem : function(record){
				doAddItem(record);
			},
			clear : function(){
				doClear();
			},
			getText : function(){
				var record = getSelectedItem();
				return record != null ? record.getShowValue() : null;
			},
			getValue : function(){
				var record = getSelectedItem();
				return record != null ? record.getValue() : null;
			},
			getAll : function(){
			    var all = [];
			    for (var i = 0, len = op.data.getLength(); i < len; i ++){
			       var nd = op.data.getRecord(i);
			       all.push({text: nd.getShowValue(), value : nd.getValue() != null ? nd.getValue() : nd.getShowValue()});
			    }
			    return all;
			},
			
			setAll : function(val){
				var self = this;
				//b:role pane only
				$.each(val, function(name, nd){
					doAddItem(FR.createItemRecord({
						text: name, value: nd
					}));
				})			
			},
			
			getItem : function(){
				return getSelectedItem();
			},
			
			setValue : function(val, it){
				var currentText = this.getText();
			    for (var index = 0, len = op.data.getLength(); index < len; index ++){
			         var dt = op.data.getRecord(index);
			         if (it){
			         	if (it.getShowValue() == dt.getShowValue()){
			         		dt.setValue(val);
			                break;
			         	}
			         } else if (dt.getShowValue() == currentText){
			         	  dt.setValue(val);
			         	  break;
			         }
			    }		  
			}
		};
		
		return me;
	}
	
	$.fn.getListText = function() {
        if (this[0].t) {
            return this[0].t.getText();
        }
        return null;
    }
    $.fn.getListValue = function() {
        if (this[0].t) {
            return this[0].t.getValue();
        }
        return null;
    }
    $.fn.getListAll = function() {
       if (this[0].t) {
            return this[0].t.getAll();
        }
       return null;
    }
    $.fn.getListItem = function() {
        if (this[0].t) {
            return this[0].t.getItem();
        }
        return null;
    }
    $.fn.addListItem = function(item){
    	if (this[0].t) {
    		return this[0].t.addItem(item);
    	}
    }
    $.fn.setListValue = function(value, item) {
        if (this[0].t) {
            this[0].t.setValue(value, item);
        }
    }
    $.fn.setListAll = function(val){
    	if (this[0].t){
    		this[0].t.setAll(val);
    	}
    }
    $.fn.clearList = function(){
    	if (this[0].t){
    		this[0].t.clear();
    	}
    }
    
})(jQuery);